#include <math.h>
#include "complex.h"
#include "fft.h"

/*simple fft (N=4) for FP-Fixer*/

// (2) input, output, inout̃fBNeBut
void fftfp(
    const complex indata[4],    // fpfix input varname=indata.real
                                // fpfix input varname=indata.image
    complex outdata[4]          // fpfix output varname=outdata.real rate=5:m
                                // fpfix output varname=outdata.image rate=5:m
)
{
    complex tmp0,tmp1,tmp2,tmp3;
    complex tmp4,tmp5,tmp6,tmp7;

    /*stage1*/
    tmp0.real =indata[0].real +indata[2].real;
    tmp0.image=indata[0].image+indata[2].image;
    tmp4.real =indata[1].real +indata[3].real;
    tmp4.image=indata[1].image+indata[3].image;
    outdata[0].real =tmp0.real +tmp4.real;
    outdata[0].image=tmp0.image+tmp4.image;

    /*stage2*/
    tmp1.real =indata[0].real -indata[2].real;
    tmp1.image=indata[0].image-indata[2].image;
    tmp5.real =indata[1].image-indata[3].image;
    tmp5.image=indata[3].real -indata[1].real;
    outdata[1].real =tmp1.real +tmp5.real;
    outdata[1].image=tmp1.image+tmp5.image;

    /*stage3*/
    tmp2.real =indata[0].real +indata[2].real;
    tmp2.image=indata[0].image+indata[2].image;
    tmp6.real =indata[1].real +indata[3].real;
    tmp6.image=indata[1].image+indata[3].image;
    outdata[2].real =tmp2.real -tmp6.real;
    outdata[2].image=tmp2.image-tmp6.image;

    /*stage4*/
    tmp3.real =indata[0].real -indata[2].real;
    tmp3.image=indata[0].image-indata[2].image;
    tmp7.real =indata[3].image-indata[1].image;
    tmp7.image=indata[1].real -indata[3].real;
    outdata[3].real =tmp3.real + tmp7.real;
    outdata[3].image=tmp3.image+ tmp7.image;
}
