/**************************************************************/
//FILE:main.c                                                 */
//DATE:2007/10/03                                             */
//example for FP-Fixer  (simple FFT)                          */
//Please type 'Fpfix -all_*** -arg input.data *.c' on console */
/**************************************************************/

//
// FP-Fixer v2.08.xx ̓f@\ׂ̈̋Lq
// (1)͑ΏۂR[Ă֐ // fpfix mpdule fBNeBuLq
// (2)͑Ώۊ֐ input, output, inout̃fBNeBuLq
// (3)$FPFIX/evfunc/fpf_evfunc.tmpl JgɃRs[
//     Kvɉĕ]eύX


#include <stdio.h>
#include <stdlib.h>
#include "complex.h"
#include "fft.h"

double fpfix_error_rate=0.05;
static int ng=0;

int cmpBuf(complex in1[SDFT_N],complex in2[SDFT_N],double erate){
    int i;
    int flg;
    double rate;
    flg=0;
    for(i=0;i<SDFT_N;i++){
        //printf("%d:in1:%f %f\n"  ,i,in1[i].real,in1[i].image);
        //printf("%d:in2:%f %f\n\n",i,in2[i].real,in2[i].image);

    if(in1[i].real<0.0) rate=-erate;
        else rate=erate;
    flg|=((((in1[i].real* (1.0+rate))<in2[i].real )) ||
               ((in1[i].real* (1.0-rate))>in2[i].real ));

    if(in1[i].image<0.0) rate=-erate;
    else rate=erate;
    flg|=((((in1[i].image*(1.0+rate))<in2[i].image)) ||
               ((in1[i].image*(1.0-rate))>in2[i].image));
    }

    if ( flg != 0 ) {
      ng++;
    }
    return flg;
}

int getData(FILE*fp,double*val) {
    static char buf[1024];
    if(fgets(buf,1024,fp)==NULL){
        *val=0.0;
    return -1;
    }
    *val=atof(buf);
    return 0;
}

/*main function*/
int main(int argc,char**argv)
{
  /*simple fft*/
  extern void fft(const complex indata[SDFT_N],complex outdata[SDFT_N]);
  /*simple fft for FP-Fixer*/
  extern void fftfp(const complex indata[SDFT_N],complex outdata[SDFT_N]);

    int i;
    int endflg;
    int totaldata;
    complex inbuf[SDFT_N];
    complex outbuf_sfft[SDFT_N];
    complex outbuf_sfftfp[SDFT_N];
    FILE*fp;
    int rr;

    if(argc!=2){
        printf("usage: <input-data>\n");
        return -1;
    }
    fp=fopen(argv[1],"r");
    if(!fp){
       perror(argv[1]);
       return -1;
    }
    endflg=0;
    totaldata=0;
    ng=0;
    rr = 0;
    while(1){
      for(i=0;i<SDFT_N;i++){
          endflg|=getData(fp,&(inbuf[i].real));
          endflg|=getData(fp,&(inbuf[i].image));
      }
      // Ғl쐬iŒ菬_C]ׁ̈j
      fft(inbuf,outbuf_sfft);
      // (1)modulefBNeBu
      fftfp(inbuf,outbuf_sfftfp); //fpfix module

      // v2.08.xx ́A͎A]֐ō쐬邽evFunc͕sv
      // AAŒ菬_C]̈׍쐬Ēu
      // i]֐Ǝɍ쐬ꍇ́Afft_0_uevQƁj
      rr |= cmpBuf(outbuf_sfft,outbuf_sfftfp,fpfix_error_rate); //fpfix evFunc
      totaldata++;
      if(endflg) break;
    }
    printf("total=%d ng=%d\n", totaldata, ng );
    fclose ( fp );

    return rr;
}
